function getElementsFromDiagram(bpmnId) {
  //In diesem Element werden die Elemente gespeichert
  var elements = [];
  $.ajax({
        url: mw.util.wikiScript( 'api' ),
        data: {
          action: 'parse',
          page: bpmnId,
          prop: 'wikitext',
          format: 'json',
        },
        type: 'GET',
        async: false,
        success: function( data ) {
            if ( data && data.edit && data.edit.result == 'Success' ) {
            //    alert ('Ich bin in der Methode mit der ID ' + shapeId);
            } else if ( data && data.error ) {
              
            } else {
                //Achtung, Seite gibt es schon!
                var data = data.parse.wikitext["*"];
               // |has_element=StartEvent_1hxqt2b,IntermediateThrowEvent_1tln6q4,EndEvent_0c2kyky|+sep=,
                var parts = data.split("|has_element=")[1].split("|+sep=,")[0].split(",");
                for (var i = 0; i < parts.length; i++) {
                  elements.push(parts[i].replace(" ","").replace("\n","")); 
                }
                
                
            }  
        },
        error: function( xhr ) {
          
        }
    });  

  return elements;                     

}

function getEntryOfElementsList(elementId) {
  var result;
  for (var i = 0; i < elementsList.length; i++) {
    if (elementsList[i].id.indexOf(elementId) == 0) {
      result = i;
      i = elementsList.length;
    }
  }

  return result;
}

function getAttribute(data, property) {
  var attribute = "";
  /*|id=StartEvent_1hxqt2b
  |xBound=163
  |yBound=173
  |width=36
  |height=36 */
  if (property.indexOf("outgoing") == 0) {
    if (data.indexOf("outgoing") > -1) {
      attribute = data.split("|outgoing=")[1].split("|+sep=,")[0];  
    }
  } else if (property.indexOf("incoming") == 0) {
    if (data.indexOf("incoming") > -1) {
      attribute = data.split("|incoming=")[1].split("|+sep=,")[0]; 
    }
  } else if (property.indexOf("type") == 0) {
    attribute = data.split("[[Category:BPMN ")[1].split("]]")[0];
    attribute = attribute.charAt(0).toLowerCase() + attribute.slice(1);
  } else {
    attribute = data.split("|" + property + "=")[1].split("|")[0];  
  }

  return attribute.replace("\n","").replace(" ","").replace("}}","");                
}


function loadWiki() {

  //Erstelle den Header Teil des XML Dokuments
  var xml = document.createElement("div");
  bpmnId = document.getElementById("bpmnID").value;

  var nodeDefinitions = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/MODEL", "bpmn2:definitions");
  nodeDefinitions.setAttribute("xmlns:bpmn2","http://www.omg.org/spec/BPMN/20100524/MODEL");
  nodeDefinitions.setAttribute("xmlns:bpmndi","http://www.omg.org/spec/BPMN/20100524/DI");
  nodeDefinitions.setAttribute("xmlns:di","http://www.omg.org/spec/DD/20100524/DI");

  nodeDefinitions.setAttribute("xmlns:dc","http://www.omg.org/spec/DD/20100524/DC");
  nodeDefinitions.setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
  nodeDefinitions.setAttribute("id","sample-diagram");
  nodeDefinitions.setAttribute("targetNamespace","http://bpmn.io/schema/bpmn");
  nodeDefinitions.setAttribute("xsi:schemaLocation","http://www.omg.org/spec/BPMN/20100524/MODEL BPMN20.xsd");

  //Füge nodeDefinitions zum xml Dokument dazu.
  xml.appendChild(nodeDefinitions);

  //Elementbeschreibung
  //<bpmn2:process id="Process_1" isExecutable="false">
  var nodeProcess = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/MODEL", "bpmn2:process");
  nodeProcess.setAttribute("id",bpmnId);
  nodeProcess.setAttribute("isExecutable","false");


  //Diagrammbeschreibung
  //<bpmndi:BPMNDiagram id="BPMNDiagram_1">
  var nodeDiagram = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/DI", "bpmndi:BPMNDiagram");
  nodeDiagram.setAttribute("id","BPMNDiagram_1");

  //for all Elements
  //Hole alle elemente aus bpmn heraus
  elementsList = [];
  elements = getElementsFromDiagram(bpmnId);
  references = [];
    //Füge Elementbeschreibung hinzu
    for(var i = 0; i < elements.length; i++) {
      var elementId = elements[i];
      //Get Element
      $.ajax({
          url: mw.util.wikiScript( 'api' ),
          data: {
            action: 'parse',
            page: elementId,
            prop: 'wikitext',
            format: 'json',
          },
          type: 'GET',
          async: false,
          success: function( data ) {
              if ( data && data.edit && data.edit.result == 'Success' ) {
              //    alert ('Ich bin in der Methode mit der ID ' + shapeId);
              } else if ( data && data.error ) {
                
              } else {
                  //Achtung, Seite gibt es schon!
                  var data = data.parse.wikitext["*"];  
                  var id = getAttribute(data, "id");
                  var xBound = getAttribute(data, "xBound");
                  var yBound = getAttribute(data, "yBound");
                  var outgoing = getAttribute(data, "outgoing");
                  var width = getAttribute(data, "width");
                  var height = getAttribute(data, "height");
                  var outgoing = getAttribute(data, "outgoing");
                  var incoming = getAttribute(data, "incoming");
                  var type = getAttribute(data, "type");       

                  elementsList.push({id:id, xBound:xBound, yBound:yBound, width:width, height:height, type:type});
                  //erstes Element
                  var elementProcess = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/MODEL", "bpmn2:" + type);
                  elementProcess.setAttribute("id", id);

                  var outgoingLinks = outgoing.split(",");
                  for (var k = 0; k < outgoingLinks.length; k++) {
                    if (outgoingLinks[k] != "") {
                      var outGoingRef = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/MODEL", "bpmn2:outgoing");
                      outGoingRef.textContent = outgoingLinks[k];
                      elementProcess.appendChild(outGoingRef); 
                      //Hier von dem Outgoing Ref die Koordinaten abstauben. Outgoing Reicht, weil outgoing ja auch gleichzeitig wieder incoming ist
                      $.ajax({
                        url: mw.util.wikiScript( 'api' ),
                        data: {
                          action: 'parse',
                          page: outgoingLinks[k],
                          prop: 'wikitext',
                          format: 'json',
                        },
                        type: 'GET',
                        async: false,
                        success: function( data ) {
                            if ( data && data.edit && data.edit.result == 'Success' ) {
                            //    alert ('Ich bin in der Methode mit der ID ' + shapeId);
                            } else if ( data && data.error ) {
                              
                            } else {
                              var data = data.parse.wikitext["*"];

                              var sourceRef = data.split("|sourceRef=")[1].split("|")[0].replace("\n","").replace(" ",""); 
                              var targetRef = data.split("|targetRef=")[1].split("\n")[0].replace("\n","").replace(" ",""); 
                              var referenceType = data.split("[[Category:")[1].split("]]")[0];
                              //Jetzt waypoints
                              var waypoints = [];
                              var waypointsArr = data.split("#subobject:WayPoint_");
                              for (var l = 1; l < waypointsArr.length; l++) {
                                var x = waypointsArr[l].split("|")[1].replace("\n","").replace("}}","").replace("x=","");
                                var y = waypointsArr[l].split("|")[2].split("}}")[0].replace("\n","").replace("y=","");
                                waypoints.push(x + ";" + y);
                              }
                              var reference = {id:outgoingLinks[k], sourceRef:sourceRef, targetRef:targetRef, bpmnType:referenceType, waypoints:waypoints};
                              references.push(reference);


                              var sequenceFlow = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/MODEL", "bpmn2:" + referenceType.charAt(0).toLowerCase() + referenceType.slice(1));
                              sequenceFlow.setAttribute("id",outgoingLinks[k]);
                              sequenceFlow.setAttribute("sourceRef",sourceRef);
                              sequenceFlow.setAttribute("targetRef",targetRef);
                              nodeProcess.appendChild(sequenceFlow);
                            }  
                        },
                        error: function( xhr ) {
                          
                        }
                    });

                    }
                    
                  }
                  var incomingLinks = incoming.split(",");
                  for (var k = 0; k < incomingLinks.length; k++) {
                    if (incomingLinks[k] != "") {
                      var incomingRef = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/MODEL", "bpmn2:incoming");
                      incomingRef.textContent = incomingLinks[k];
                      elementProcess.appendChild(incomingRef);
                    }
                  }
                  

                  //füge Element Prozess hinzu
                  nodeProcess.appendChild(elementProcess);

                  
              }  
          },
          error: function( xhr ) {
            
          }
      }); 
       
    }


    //Füge Beschreibung der Verbindungen hinzu (BPMNDiagram)
    //Zuerst Panes hinzufügen --> hier nur eins
    //<bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_1">
    var plane = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/DI", "bpmndi:BPMNPlane");
    plane.setAttribute("id", "BPMNPlane_1");
    plane.setAttribute("bpmnElement", "Process_1");

    //Alle elements dem Plane zuordnen
    for (var j = 0; j < elementsList.length; j++) {
      var shape = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/DI", "bpmndi:BPMNShape");
      shape.setAttribute("id", elementsList[j].id + "_di");
      shape.setAttribute("bpmnElement", elementsList[j].id);

      var bounds = document.createElementNS("http://www.omg.org/spec/DD/20100524/DC", "dc:Bounds");
      bounds.setAttribute("x", elementsList[j].xBound);
      bounds.setAttribute("y", elementsList[j].yBound);
      bounds.setAttribute("width", elementsList[j].width);
      bounds.setAttribute("height", elementsList[j].height);
      shape.appendChild(bounds);
      //mal ohne labels
      plane.appendChild(shape);
    }

    //Jetzt Links und dann war's das?
    for (var j = 0; j < references.length; j++) {
      var edge = document.createElementNS("http://www.omg.org/spec/BPMN/20100524/DI", "bpmndi:BPMNEdge");
      edge.setAttribute("id", references[j].id + "_di");
      edge.setAttribute("bpmnElement", references[j].id);
      
      for (var m = 0; m < references[j].waypoints.length; m++) {
        var waypoint1 = document.createElementNS("http://www.omg.org/spec/DD/20100524/DI", "di:waypoint"); 
        waypoint1.setAttribute("xsi:type","dc:Point");
        var x = references[j].waypoints[m].split(";")[0];
        var y = references[j].waypoints[m].split(";")[1];
        waypoint1.setAttribute("x",x);
        waypoint1.setAttribute("y",y);
        edge.appendChild(waypoint1);
      }
      //mal ohne labels
      plane.appendChild(edge);
    }


    nodeDiagram.appendChild(plane);

  //Element- und Diagrammbeschreibung dem xml Dokument übergeben
  nodeDefinitions.appendChild(nodeProcess);
  nodeDefinitions.appendChild(nodeDiagram);


  //Ausgabe des Dokuments via alert
  //alert("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" + xml.innerHTML);
  var xmlValue = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" + xml.innerHTML;
  //var xmlValue = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> <bpmn2:definitions xmlns:bpmn2=\"http://www.omg.org/spec/BPMN/20100524/MODEL\" xmlns:bpmndi=\"http://www.omg.org/spec/BPMN/20100524/DI\" xmlns:di=\"http://www.omg.org/spec/DD/20100524/DI\" xmlns:dc=\"http://www.omg.org/spec/DD/20100524/DC\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" id=\"sample-diagram\" targetNamespace=\"http://bpmn.io/schema/bpmn\" xsi:schemaLocation=\"http://www.omg.org/spec/BPMN/20100524/MODEL BPMN20.xsd\"><bpmn2:process id=\"BPMNProcess_MyProcesswefw\" isExecutable=\"false\"><bpmn2:sequenceFlow id=\"SequenceFlow_1jxsefw\" sourceRef=\"StartEvent_14wiovp\" targetRef=\"Task_1f38jaf\"></bpmn2:sequenceFlow><bpmn2:startEvent id=\"StartEvent_14wiovp\"><bpmn2:outgoing>SequenceFlow_1jxsefw</bpmn2:outgoing></bpmn2:startEvent><bpmn2:task id=\"Task_1f38jaf\"><bpmn2:incoming>SequenceFlow_063vsx6</bpmn2:incoming></bpmn2:task><bpmn2:sequenceFlow id=\"SequenceFlow_063vsx6\" sourceRef=\"StartEvent_1cyawsk\" targetRef=\"Task_1f38jaf\"></bpmn2:sequenceFlow><bpmn2:startEvent id=\"StartEvent_1cyawsk\"><bpmn2:outgoing>SequenceFlow_063vsx6</bpmn2:outgoing></bpmn2:startEvent></bpmn2:process><bpmndi:BPMNDiagram id=\"BPMNDiagram_1\"><bpmndi:BPMNPlane id=\"BPMNPlane_1\" bpmnElement=\"Process_1\"><bpmndi:BPMNShape id=\"StartEvent_14wiovp_di\" bpmnElement=\"StartEvent_14wiovp\"><dc:Bounds x=\"224\" y=\"397\" width=\"36\" height=\"36\"></dc:Bounds></bpmndi:BPMNShape><bpmndi:BPMNShape id=\"Task_1f38jaf_di\" bpmnElement=\"Task_1f38jaf\"><dc:Bounds x=\"422\" y=\"272\" width=\"100\" height=\"80\"></dc:Bounds></bpmndi:BPMNShape><bpmndi:BPMNShape id=\"StartEvent_1cyawsk_di\" bpmnElement=\"StartEvent_1cyawsk\"><dc:Bounds x=\"224\" y=\"252\" width=\"36\" height=\"36\"></dc:Bounds></bpmndi:BPMNShape><bpmndi:BPMNEdge id=\"SequenceFlow_1jxsefw_di\" bpmnElement=\"SequenceFlow_1jxsefw\"><di:waypoint xsi:type=\"dc:Point\" x=\"224\" y=\"397\"></di:waypoint><di:waypoint xsi:type=\"dc:Point\" x=\"422\" y=\"272\"></di:waypoint></bpmndi:BPMNEdge><bpmndi:BPMNEdge id=\"SequenceFlow_063vsx6_di\" bpmnElement=\"SequenceFlow_063vsx6\"><di:waypoint xsi:type=\"dc:Point\" x=\"224\" y=\"252\"></di:waypoint><di:waypoint xsi:type=\"dc:Point\" x=\"422\" y=\"272\"></di:waypoint></bpmndi:BPMNEdge></bpmndi:BPMNPlane></bpmndi:BPMNDiagram></bpmn2:definitions>";
  renderer.importXML(xmlValue, function(err) {

    if (err) {
      container
        .removeClass('with-diagram')
        .addClass('with-error');

      container.find('.error pre').text(err.message);

      console.error(err);
    } else {
      container
        .removeClass('with-error')
        .addClass('with-diagram');
    }


  });
  document.getElementById('contentForm').style.display = 'none';
  document.getElementById('loadDivWrong').style.display = 'none';
  document.getElementById('contentBPMN').style.display = 'block'; 
}  